public abstract class Passenger {

    protected Transport currentTransport;
    protected boolean isInTransport;
    protected boolean isSeated;
    private int totalNBstops;
    private int currentNBstops;

    public final String fullName;

    protected Passenger(int stopNumbers, String name) {
        this.fullName = name;
        this.currentTransport = null;
        this.isInTransport = false;
        this.isSeated = false;
        this.totalNBstops = stopNumbers;
        this.currentNBstops = 0;
    }

    public void notifyNextStop() {
        currentNBstops++;
        if (currentNBstops >= totalNBstops) this.leave(currentTransport);
    }

    protected abstract void requestPlace(Transport t);

    protected void leave(Transport t) {
        t.removePassenger(this);
        this.currentTransport=null;
    }

}